// naumann@stce.rwth-aachen.de

#include <iostream>
#include <cassert>
#include <cmath>
#include <vector> // stdlib vectors

/* takes vector of observations y at corresponding positions x 
   and returns optimal estimate for free parameter p of model y=p*x */
float estimate(std::vector<float> x, std::vector<float> y) { 
  assert(x.size()==y.size());
  float xTy=0,xTx=0;
  for (size_t /* unsigned integer type */i=0;i<x.size();i++) { 
    xTy+=x[i]*y[i]; 
    xTx+=pow(x[i],2); 
  }
  assert(xTx!=0);
  return xTy/xTx;
}

int main() {
  int m=0; // size of data
  std::cout << "m="; std::cin >> m;
  std::vector<float> x(m,0),y(m,0); // initialized vectors to hold data
  for (int i=0;i<m;i++) { 
    std::cout << "x[" << i << "]="; std::cin >> x[i];
    std::cout << "y[" << i << "]="; std::cin >> y[i];
  }
  float p=estimate(x,y); 
  std::cout << "p=" << p << std::endl; 
  return 0;
}
