// naumann@stce.rwth-aachen.de

#include <iostream>
#include <cassert>
#include <cmath>
#include <vector> // stdlib vectors

/* takes vector of observations y at corresponding positions x 
   and returns optimal estimate for free parameter p of model y=p*x^2 */
float estimate(std::vector<float> x, std::vector<float> y) { 
  assert(x.size()==y.size());
  float x2Ty=0,x2Tx2=0;
  for (size_t /* unsigned integer type */i=0;i<x.size();i++) { 
    x2Ty+=pow(x[i],2)*y[i]; 
    x2Tx2+=pow(x[i],4); 
  }
  assert(x2Tx2!=0);
  return x2Ty/x2Tx2;
}

int main() {
  int m=0; // size of data
  std::cout << "m="; std::cin >> m;
  std::vector<float> x(m,0),y(m,0); // initialized vectors to hold data
  for (int i=0;i<m;i++) { 
    std::cout << "x[" << i << "]="; std::cin >> x[i];
    std::cout << "y[" << i << "]="; std::cin >> y[i];
  }
  float p=estimate(x,y); 
  std::cout << "p=" << p << std::endl; 
  return 0;
}
