// naumann@stce.rwth-aachen.de

#include <iostream>
#include <cassert> 
#include <cmath>
#include <vector>
#include <fstream> // file i/o

float estimate(std::vector<float> x, std::vector<float> y) { 
  float xTy=0,xTx=0;
  for (size_t i=0;i<x.size();i++) { xTy+=x[i]*y[i]; xTx+=pow(x[i],2); }
  assert(xTx!=0); return xTy/xTx;
}

int main() {
  std::string data_file_name; // string
  std::cout << "name of data file="; std::cin >> data_file_name;
  std::ifstream data_file_read; // enables read access to file
  data_file_read.open(data_file_name); // open data file for reading
  float p=0; data_file_read >> p; // read value of free parameter from file
  size_t m=0; data_file_read >> m; // read integer size of data from file
  std::vector<float> x(m+1),y(m+1); // given data and single new data item
  for (size_t i=0;i<m;i++) { 
    data_file_read >> x[i]; assert(x[i]>0);
    data_file_read >> y[i]; assert(y[i]>0);
  }
  data_file_read.close(); // close data file

  std::cout << "new data item:" << std::endl; 
  std::cout << "x="; std::cin >> x[m]; std::cout << "y="; std::cin >> y[m];
  p=estimate(x,y); 
  std::cout << "p=" << p << std::endl; 

  std::ofstream data_file_write; // enables write access to file
  data_file_write.open(data_file_name); // open data file for overwriting 
  data_file_write << p << std::endl << m+1 << std::endl; // update data file
  for (size_t i=0;i<=m;i++) data_file_write << x[i]  << " " << y[i] << std::endl;
  data_file_write.close(); // close data file
  return 0;
}
